image: getto/hangar:e4fAdPYAfJ7vocYr-20200127105916

stages:
  - image_build
  - image_test
  - image_fix_vulnerabilities
  - image_push
  - bump_version
  - release
  - release_notify

image_build:
  stage: image_build
  only:
    refs:
      - merge_requests
    changes:
      - Dockerfile

  image: getto/hangar:latest

  variables:
    DOCKER_HOST: tcp://docker:2375/
    DOCKER_DRIVER: overlay2
    DOCKER_CONTENT_TRUST: 1
  services:
    - docker:dind

  cache:
    paths:
      - .cache

  script:
    - getto-hangar-build.sh

image_test:
  stage: image_test
  only:
    refs:
      - schedules
    variables:
      - $CHECK

  image: getto/hangar:latest

  variables:
    DOCKER_HOST: tcp://docker:2375/
    DOCKER_DRIVER: overlay2
    DOCKER_CONTENT_TRUST: 1
  services:
    - docker:dind

  cache:
    paths:
      - .cache

  script:
    - getto-hangar-test.sh

image_fix_vulnerabilities:
  stage: image_fix_vulnerabilities
  only:
    refs:
      - schedules
    variables:
      - $CHECK
  when: on_failure

  image: getto/hangar:latest

  before_script:
    - git config user.email admin@getto.systems
    - git config user.name getto
    - export PATH=$PATH:./bin
  script:
    - getto-hangar-fix-vulnerabilities.sh
    - curl https://trellis.getto.systems/ci/bump-version/1.2.1/request.sh | bash -s -- ./.fix-vulnerabilities-message.sh

image_push:
  stage: image_push
  only:
    refs:
      - master@getto-systems-base/labo/git/post
    changes:
      - Dockerfile
  except:
    refs:
      - schedules
      - triggers

  image: getto/hangar:latest

  variables:
    DOCKER_HOST: tcp://docker:2375/
    DOCKER_DRIVER: overlay2
    DOCKER_CONTENT_TRUST: 1
  before_script:
    - git config user.email admin@getto.systems
    - git config user.name getto
    - export PATH=$PATH:./bin
  services:
    - docker:dind

  script:
    - getto-hangar-push.sh
    - curl https://trellis.getto.systems/ci/bump-version/1.2.1/request.sh | bash -s -- ./.fix-image-message.sh

bump_version:
  stage: bump_version
  only:
    refs:
      - triggers
    variables:
      - $RELEASE

  image: buildpack-deps:disco-scm

  before_script:
    - git config user.email admin@getto.systems
    - git config user.name getto
    - export PATH=$PATH:./bin
  script:
    - curl https://trellis.getto.systems/ci/bump-version/1.2.1/bump_version.sh | bash
    - curl https://trellis.getto.systems/ci/bump-version/1.2.1/request.sh | bash -s -- ./.bump-message.sh

release:
  stage: release
  only:
    refs:
      - master@getto-systems-base/labo/git/post
    changes:
      - .release-version
  except:
    refs:
      - triggers
      - schedules

  script:
    - curl https://trellis.getto.systems/ci/bump-version/1.2.1/push_tags.sh | bash
    - ./scripts/deploy.sh

release_success:
  stage: release_notify
  only:
    refs:
      - master@getto-systems-base/labo/git/post
    changes:
      - .release-version
  except:
    refs:
      - triggers
      - schedules
  when: on_success

  image: buildpack-deps:disco-curl

  before_script:
    - export channel=$SLACK_CHANNEL
  script:
    - ./scripts/check_version.sh
    - curl https://trellis.getto.systems/psycher/getto/2.5.6/notify-release.sh | bash -s -- -l $GETTO_PSYCHER_URL?$GETTO_PSYCHER_TOKEN=true success

release_failure:
  stage: release_notify
  only:
    refs:
      - master@getto-systems-base/labo/git/post
    changes:
      - .release-version
  except:
    refs:
      - triggers
      - schedules
  when: on_failure

  image: buildpack-deps:disco-curl

  before_script:
    - export channel=$SLACK_CHANNEL
  script:
    - curl https://trellis.getto.systems/psycher/getto/2.5.6/notify-release.sh | bash -s -- -l $GETTO_PSYCHER_URL?$GETTO_PSYCHER_TOKEN=true failure
